SystemOrganization addCategory: #ParcialCanalCamprodon!

OrderedCollection subclass: #Matriu
	instanceVariableNames: 'mida_dimensio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialCanalCamprodon'!

!Matriu class methodsFor: 'instance creation' stamp: 'GerardCanal 11/1/2012 17:22'!
new: aNombre
	^(super new: aNombre squared) initialize.
! !

!Matriu class methodsFor: 'instance creation' stamp: 'GerardCanal 11/1/2012 19:52'!
new: aNombre with: aValue
	^(super new: aNombre squared) initialize: aValue.! !

!Matriu methodsFor: 'arithmetic' stamp: 'GerardCanal 11/1/2012 19:00'!
+ unaMatriu
	|novaMat|
	self size = unaMatriu size
		ifFalse: [self error: 'No es pot sumar dues matrius de diferents mides.']
		ifTrue: [
			novaMat := Matriu new: mida_dimensio.
			1 to: mida_dimensio do: [:i |
					1 to: mida_dimensio do:[:j |
						|p|
						p := i @ j.
						novaMat at: p put: (self at: p) + (unaMatriu at: p).
						].
				].
		].
	^novaMat! !

!Matriu methodsFor: 'arithmetic' stamp: 'GerardCanal 11/1/2012 19:02'!
- unaMatriu
	|novaMat|
	self size = unaMatriu size
		ifFalse: [self error: 'No es pot restar dues matrius de diferents mides.']
		ifTrue: [
			novaMat := Matriu new: mida_dimensio.
			1 to: mida_dimensio do: [:i |
					1 to: mida_dimensio do:[:j |
						|p|
						p := i @ j.
						novaMat at: p put: (self at: p) - (unaMatriu at: p).
						].
				].
		].
	^novaMat! !

!Matriu methodsFor: 'comparing' stamp: 'GerardCanal 11/1/2012 18:51'!
= unaMatriu
	self size = unaMatriu size
		ifFalse:[^false]
		ifTrue: [
			1 to: mida_dimensio do: [:i |
					1 to: mida_dimensio do:[:j |
						|p|
						p := i @ j.
						(self at: p) = (unaMatriu at: p)
							ifFalse: [^false].
						].
				].
			^true.
		]! !

!Matriu methodsFor: 'adding' stamp: 'GerardCanal 11/1/2012 20:08'!
add: aValue
	self shouldNotImplement .! !

!Matriu methodsFor: 'accessing' stamp: 'GerardCanal 11/1/2012 18:29'!
at: aParell
	^super at:  (self oneDimensionPosition: aParell)! !

!Matriu methodsFor: 'accessing' stamp: 'GerardCanal 11/1/2012 18:29'!
at: aParell put: aValor
	^super at: (self oneDimensionPosition: aParell) put: aValor.! !

!Matriu methodsFor: 'initialize-release' stamp: 'GerardCanal 11/1/2012 20:14'!
initialize 
	|s|
	s := self capacity.
	mida_dimensio := s sqrt.
	s timesRepeat: [super add: nil].
	^self.! !

!Matriu methodsFor: 'initialize-release' stamp: 'GerardCanal 11/1/2012 20:14'!
initialize: aValue
	|s|
	s := self capacity.
	mida_dimensio := s sqrt.
	s timesRepeat: [super add: aValue].
	^self.! !

!Matriu methodsFor: 'accessing' stamp: 'GerardCanal 11/1/2012 17:27'!
numberOfElements
	^super size.! !

!Matriu methodsFor: 'private' stamp: 'GerardCanal 11/1/2012 18:30'!
oneDimensionPosition: aPoint
	|i j|
	i := (aPoint x) - 1 * mida_dimensio .
	j := (aPoint y) .
	^i + j ! !

!Matriu methodsFor: 'printing' stamp: 'GerardCanal 11/1/2012 19:01'!
printOn: aStream
	1 to: self numberOfElements do: [:i |
		aStream nextPutAll: (super at: i) asString.
		(i \\ mida_dimensio) = 0 ifTrue:  [aStream nextPutAll: Character cr asString]
						     		 ifFalse: [aStream nextPutAll: Character tab asString]
	]! !

!Matriu methodsFor: 'accessing' stamp: 'GerardCanal 11/1/2012 17:27'!
size
	"Retorna el tamany d'una dimensi de la Matriu (com que la matriu s quadrada, en realitat retorna les dues dimensions)"
	^ mida_dimensio.! !

Object subclass: #ParcialCanalCamprodon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialCanalCamprodon'!

!ParcialCanalCamprodon class methodsFor: 'Respostes' stamp: 'GerardCanal 11/9/2012 11:30'!
pregunta1 
	^ParcialCanalCamprodon new pregunta1.! !

!ParcialCanalCamprodon class methodsFor: 'Respostes' stamp: 'GerardCanal 11/9/2012 11:30'!
pregunta2
	^ParcialCanalCamprodon new pregunta2.! !

!ParcialCanalCamprodon class methodsFor: 'Respostes' stamp: 'GerardCanal 11/9/2012 11:30'!
pregunta3
	^ParcialCanalCamprodon new pregunta3.! !

!ParcialCanalCamprodon class methodsFor: 'Respostes' stamp: 'GerardCanal 11/9/2012 11:30'!
pregunta4
	^ParcialCanalCamprodon new pregunta4.! !

!ParcialCanalCamprodon class methodsFor: 'Respostes' stamp: 'GerardCanal 11/9/2012 11:30'!
pregunta5
	^ParcialCanalCamprodon new pregunta5.! !

!ParcialCanalCamprodon class methodsFor: 'Respostes' stamp: 'GerardCanal 11/9/2012 11:30'!
pregunta6
	^ParcialCanalCamprodon new pregunta6.! !

!ParcialCanalCamprodon class methodsFor: 'Respostes' stamp: 'GerardCanal 11/9/2012 11:30'!
totesLesRespostes 
	^ParcialCanalCamprodon new totesLesRespostes .! !

!ParcialCanalCamprodon methodsFor: 'Respostes' stamp: 'GerardCanal 11/9/2012 11:35'!
pregunta1
	"La resposta es pot trobar a la classe Matriu del paquet ParcialCanalCamprodon. Nota: he utiltzat la classe Point per representar la posici de la matriu (el unParell de l'enunciat).
	 He implementat el nou new: que crida al constructor de la superclasse. Tamb el new:aNumber with:aValue, que crea una matriu de mida aNumber amb el valor aValue a totes les posicions.
	 He fet que el initialize crei la matriu amb el tamany corresponent i inicializada a nil (i el initialize: per a un valor diferent a nil), per tal que el at: no dongui error
	 quan aquest encara no est inicializat (considero que si declarem una matriu de NxN, accedir a una posici per collocar-hi un valor no hauria de resultar en error).
	 Tamb he implementat la suma, la resta i la igualtat, aix com el size que retorna el tamany d'una dimensi, i el numberOfElements que retorna el nombre d'elements total.
   	 He desactivat el missage add: (noms aquest, per tamb s'hauria pogut fer amb el altes addFirst:, etc.) ja que la meva Matriu s de mida fixa i no permeto afegir elements amb add:,
	 sino que est ja inicializada i s'ha de recrrer (p.e. com a la suma) per modificar valors. Per desctivar-lo he utilitzat el shouldNotImplement.
	 He creat uns tests per tal de provar les diferents operacions."
	
Transcript show: 'La resposta es pot trobar a la classe Matriu del paquet ParcialCanalCamprodon. Nota: he utiltzat la classe Point per representar la posici de la matriu (el unParell de l''enunciat).
	 He implementat el nou new: que crida al constructor de la superclasse. Tamb el new:aNumber with:aValue, que crea una matriu de mida aNumber amb el valor aValue a totes les posicions.
	 He fet que el initialize crei la matriu amb el tamany corresponent i inicializada a nil (i el initialize: per a un valor diferent a nil), per tal que el at: no dongui error
	 quan aquest encara no est inicializat (considero que si declarem una matriu de NxN, accedir a una posici per collocar-hi un valor no hauria de resultar en error).
	 Tamb he implementat la suma, la resta i la igualtat, aix com el size que retorna el tamany d''una dimensi, i el numberOfElements que retorna el nombre d''elements total.
   	 He desactivat el missage add: (noms aquest, per tamb s''hauria pogut fer amb el altes addFirst:, etc.) ja que la meva Matriu s de mida fixa i no permeto afegir elements amb add:,
	 sino que est ja inicializada i s''ha de recrrer (p.e. com a la suma) per modificar valors. Per desctivar-lo he utilitzat el shouldNotImplement.
	 He creat uns tests per tal de provar les diferents operacions.'! !

!ParcialCanalCamprodon methodsFor: 'Respostes' stamp: 'GerardCanal 11/9/2012 02:20'!
pregunta2
	"La introspecci s l'habilitat d'un programa d'observar o examinar el seu propi estat i, per tant, de raonar sobre aquest estat.
	 La intercessi s l'habilitat d'un programa de modificar el seu propi estat o d'alterar la seva prpia interpretaci o significat, podent afegir nou comportament al programa que s'est executant.
	 La reificaci s el mecanisme per tal de fer una codificaci d'un estat d'execuci com a dades.
	Smalltalk t introspecci i intercessi, per no reifica l'enviament de missatges per el qual no podem dir que sigui reflexiu del tot. Java noms t introspecci (els Proxies sn l'nic mecanisme de Java per interceptar la invocaci de mtodes).
	Per tant, Smalltalk s'acosta ms que Java a ser reflexiu del tot, ja que poseeix mecanismes que li permeten disposar d'introspecci i d'intercessi."
	
	Transcript show: 'La introspecci s l''habilitat d''un programa d''observar o examinar el seu propi estat i, per tant, de raonar sobre aquest estat.
	 La intercessi s l''habilitat d''un programa de modificar el seu propi estat o d''alterar la seva prpia interpretaci o significat, podent afegir nou comportament al programa que s''est executant.
	 La reificaci s el mecanisme per tal de fer una codificaci d''un estat d''execuci com a dades.
	Smalltalk t introspecci i intercessi, per no reifica l''enviament de missatges per el qual no podem dir que sigui reflexiu del tot. Java noms t introspecci (els Proxies sn l''nic mecanisme de Java per interceptar la invocaci de mtodes).
	Per tant, Smalltalk s''acosta ms que Java a ser reflexiu del tot, ja que poseeix mecanismes que li permeten disposar d''introspecci i d''intercessi.'! !

!ParcialCanalCamprodon methodsFor: 'Respostes' stamp: 'GerardCanal 11/9/2012 10:44'!
pregunta3 
	"Com que en ambds llenguatges les classes tamb sn objectes, com a tals objectes les classes tamb han de ser instncies d'altres classes (o sigui, d'una metaclasse). Tamb sn tils per a la reflexi, doncs ens permeten reificar les classes.
	En Java existeix una nica metaclasse anomenada Class, de la qual totes les classes en sn instncia. 
	En Smalltalk, en canvi, cada classe t la seva prpia metaclasse, creada implcitament al crear la classe. A ms, no hi ha compartici com a Java ja que tota classe s instncia nica de la seva metaclasse. D'altra banda, la jerarquia de metaclasses en Smalltalk s equivalent a la jerarquia de classes.
	En Java la classe Class (la nica metaclasse) s instncia d'ella mateixa. En Smalltalk, tota meclasse s instncia de la classe MetaClass, i MetaClass com a classe tamb s instncia d'una metaclasse anomenada ''MetaClass class',  que com totes les metaclasses tamb s instncia de MetaClass.
	Aquesta diferncia implica que a Java totes les classes tenen la mateixa estructura i comportament, de manera que no tindriem mtodes diferents per a crear instncies. En Smalltalk aix no passa donat que cada classe te la seva prpia metaclasse, fent que no totes les classes tinguin la mateixa estructura. 
Aquesta diferncia tamb implica un disseny diferent en la jerarquia i estructura de les classes i metaclasses: com hem dit, MetaClass s instncia de 'MetaClass class', i 'MetaClass class' s instncia de MetaClass. Aquesta circularitat s necessria per evitar una cadena d'instncies de metaclasses infinita (ja que si no fos aix, MetaClass class necessitaria una altra metaclasse i aix ad infinitum). Java tamb soluciona aquesta 'cadena infinita' mitjanant una circularitat diferent (Class s instncia d'ella mateixa) degut al fet que a l'nica metaclasse existent s Class."
	
	Transcript show: 
		'Com que en ambds llenguatges les classes tamb sn objectes, com a tals objectes les classes tamb han de ser instncies d''altres classes (o sigui, d''una metaclasse). Tamb sn tils per a la reflexi, doncs ens permeten reificar les classes.
	En Java existeix una nica metaclasse anomenada Class, de la qual totes les classes en sn instncia. 
	En Smalltalk, en canvi, cada classe t la seva prpia metaclasse, creada implcitament al crear la classe. A ms, no hi ha compartici com a Java ja que tota classe s instncia nica de la seva metaclasse. D''altra banda, la jerarquia de metaclasses en Smalltalk s equivalent a la jerarquia de classes.
	En Java la classe Class (la nica metaclasse) s instncia d''ella mateixa. En Smalltalk, tota meclasse s instncia de la classe MetaClass, i MetaClass com a classe tamb s instncia d''una metaclasse anomenada ''MetaClass class'',  que com totes les metaclasses tamb s instncia de MetaClass.
	Aquesta diferncia implica que a Java totes les classes tenen la mateixa estructura i comportament, de manera que no tindriem mtodes diferents per a crear instncies. En Smalltalk aix no passa donat que cada classe te la seva prpia metaclasse, fent que no totes les classes tinguin la mateixa estructura. 
Aquesta diferncia tamb implica un disseny diferent en la jerarquia i estructura de les classes i metaclasses: com hem dit, MetaClass s instncia de ''MetaClass class'', i ''MetaClass class'' s instncia de MetaClass. Aquesta circularitat s necessria per evitar una cadena d''instncies de metaclasses infinita (ja que si no fos aix, MetaClass class necessitaria una altra metaclasse i aix ad infinitum). Java tamb soluciona aquesta ''cadena infinita'' mitjanant una circularitat diferent (Class s instncia d''ella mateixa) degut al fet que a l''nica metaclasse existent s Class.'! !

!ParcialCanalCamprodon methodsFor: 'Respostes' stamp: 'GerardCanal 11/9/2012 09:45'!
pregunta4
	"Si estem dins d'un mtode m i executem '^expressi', aquest mtode retornar al sender del thisContext avaluat dins del mtode m.
	Si en canvi el que avaluem al mtode m s un bloc que cont ^expressi, el thisContext dins del bloc tindr com a sender el mtode m (que avalua el bloc), i com a closureOrNil tindr un BlockClosure que contindr un outerContext. Aquest outerContext s un MethodContext que cont el context d'execuci del mtode on va ser creat el bloc (diguem-li m_creador), i el sender d'aquest outerContext ser el methodContext que ha originat el missatge al mtode que ha creat el bloc (m_creador) i, per tant, capturat el seu context d'execuci (el context d'execuci de m_creador). Quan s'avalui l'expressi de retorn de dins del bloc (quan l'avalui el mtode m), aquesta far que es retorni al sender que hi ha a l'outerContext (i no al sender del thisContext). Dit en altres paraules (de manera una mica ms clara), el retorn es realitzar com si l'expressi de retorn hagus estat executada dins del mtode que ha creat el bloc. 
	Els elements de la pila d'execuci que reifica thisContext sn instncies de la classe MethodContext."
	
	Transcript show:
		'Si estem dins d''un mtode m i executem ''^expressi'', aquest mtode retornar al sender del thisContext avaluat dins del mtode m.
	Si en canvi el que avaluem al mtode m s un bloc que cont ^expressi, el thisContext dins del bloc tindr com a sender el mtode m (que avalua el bloc), i com a closureOrNil tindr un BlockClosure que contindr un outerContext. Aquest outerContext s un MethodContext que cont el context d''execuci del mtode on va ser creat el bloc (diguem-li m_creador), i el sender d''aquest outerContext ser el methodContext que ha originat el missatge al mtode que ha creat el bloc (m_creador) i, per tant, capturat el seu context d''execuci (el context d''execuci de m_creador). Quan s''avalui l''expressi de retorn de dins del bloc (quan l''avalui el mtode m), aquesta far que es retorni al sender que hi ha a l''outerContext (i no al sender del thisContext). Dit en altres paraules (de manera una mica ms clara), el retorn es realitzar com si l''expressi de retorn hagus estat executada dins del mtode que ha creat el bloc. 
	Els elements de la pila d''execuci que reifica thisContext sn instncies de la classe MethodContext.'! !

!ParcialCanalCamprodon methodsFor: 'Respostes' stamp: 'GerardCanal 11/9/2012 10:22'!
pregunta5
	"Implementat a #pregunta5:"
	
	Transcript show: '
	Implementaci de l''haltIf. Travessa la pila d''execuci cercant si l''estat actual ha estat assolit a travs d''un missatge amb sellector unSelector. 
	El mtode s''anomena pregunta5:  i es pot fer servir com a pregunta5: #selector. A la classe Pregunta5Demo hi ha un exemple, que es pot executar fent Pregunta5Demo new shouldHalt i Pregunta5Demo new shouldNotHalt, el primer atura perqu compleix l''haltif, i l''altre no.
	Implementaci: 
	
	|context|
	context := thisContext.
	[context sender isNil not]
		whileTrue: [
				context := context sender.
				context selector = unSelector 
					ifTrue: [self halt].			
			].
	^self.'! !

!ParcialCanalCamprodon methodsFor: 'Respostes' stamp: 'GerardCanal 11/9/2012 11:08'!
pregunta5: unSelector
	"Implementaci de l'haltIf. Travessa la pila d'execuci cercant si l'estat actual ha estat assolit a travs d'un missatge amb sellector unSelector. 
	Per tal de poder cridar-lo com a haltIf s'hauria de posar en un mtode anomenat haltIf, i posar-lo a Object, per l'anomeno aix al ser la resposta a la pregunta 5,
	de manera que es pot fer servir com a pregunta5: #selector. A la classe Pregunta5Demo hi ha un exemple, que es pot executar fent Pregunta5Demo new shouldHalt i Pregunta5Demo new shouldNotHalt, el primer atura perqu compleix l'haltif, i l'altre no."

	|context|
	context := thisContext.
	[context sender isNil not]
		whileTrue: [
				context := context sender.	
				context selector = unSelector
					ifTrue: [self halt].
				
		].! !

!ParcialCanalCamprodon methodsFor: 'Respostes' stamp: 'GerardCanal 11/9/2012 11:48'!
pregunta6
	"Implementat en l'arxiu 'HaltIf.java', incls a l'arxiu comprimit de l'entrega via el rac. S'inclou tamb dues classes de Test, ambdues sn idntiques excepte en el fet que una te per defecte el comportament de fer Halt (linia comentada en el beginChain() ) i l'altra no. A ms, HaltIfDemo1 utilitza el Class.forName() i el invoke() per tal de fer la crrega de la classe de forma dinmica i la crida a la funci de manera que s'utilizen tcniques de reflexi de les apreses a classe. 
	El haltIf atura el programa quan a la pila d'execuci existeix un mtode anomenat de la mateixa manera que el String que rep per parmetre.
	La funci halt() atura l'execuci i fa que s'imprimeixi a la consola la pila d'execuci i demana a l'usuari si desitja aturar l'execuci o continuar-la (mitjanant l'escriptura de una C o una A)."
	
Transcript show:
	'Implementat en l''arxiu ''HaltIf.java'', incls a l''arxiu comprimit de l''entrega via el rac. S''inclou tamb dues classes de Test, ambdues sn idntiques excepte en el fet que una te per defecte el comportament de fer Halt (linia comentada en el beginChain() ) i l''altra no. A ms, HaltIfDemo1 utilitza el Class.forName() i el invoke() per tal de fer la crrega de la classe de forma dinmica i la crida a la funci de manera que s''utilizen tcniques de reflexi de les apreses a classe. 
	El haltIf atura el programa quan a la pila d''execuci existeix un mtode anomenat de la mateixa manera que el String que rep per parmetre.
	La funci halt() atura l''execuci i fa que s''imprimeixi a la consola la pila d''execuci i demana a l''usuari si desitja aturar l''execuci o continuar-la (mitjanant l''escriptura de una C o una A).'! !

!ParcialCanalCamprodon methodsFor: 'Respostes' stamp: 'GerardCanal 11/4/2012 22:42'!
totesLesRespostes
	|name|
	name := 'pregunta'.
	1 to: 6 do: [:i | 
		Transcript show: 'Resposta a la pregunta ', i asString , ': ';cr;cr. 
		self perform: (name,i asString) asSymbol. 
		Transcript cr;cr. ].! !

Object subclass: #Pregunta5Demo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialCanalCamprodon'!

!Pregunta5Demo methodsFor: 'as yet unclassified' stamp: 'GerardCanal 11/9/2012 11:30'!
haltDemo 
	ParcialCanalCamprodon new pregunta5: #shouldHalt ."pregunta5: s el mtode que implementa l'haltif, i s dins la classe del parcial."
	^'haltDemo'.! !

!Pregunta5Demo methodsFor: 'as yet unclassified' stamp: 'GerardCanal 11/4/2012 22:13'!
shouldHalt
	^(self haltDemo), ' hauria d''haver fet halt'.! !

!Pregunta5Demo methodsFor: 'as yet unclassified' stamp: 'GerardCanal 11/4/2012 22:06'!
shouldNotHalt
	^(self haltDemo), ' no hauria d''haver fet halt'.! !

TestCase subclass: #MatriuTest
	instanceVariableNames: 'mat1 mat2 mat11 mat3 mat10s'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialCanalCamprodon'!

!MatriuTest methodsFor: 'initialize-release' stamp: 'GerardCanal 11/1/2012 20:02'!
setUp
	mat1 := (Matriu new: 3) 
	at: 1@1 put:1;
	at: 1@2 put:2;
	at: 1@3 put:3;
	at: 2@1 put:4;
	at: 2@2 put:5;
	at: 2@3 put:6;
	at: 3@1 put:7;
	at: 3@2 put:8;
	at: 3@3 put:9;
	yourself.
	mat11 := (Matriu new: 3) 
	at: 1@1 put:1;
	at: 1@2 put:2;
	at: 1@3 put:3;
	at: 2@1 put:4;
	at: 2@2 put:5;
	at: 2@3 put:6;
	at: 3@1 put:7;
	at: 3@2 put:8;
	at: 3@3 put:9;
	yourself.
	mat2  := (Matriu new: 3) 
	at: 1@1 put:2;
	at: 1@2 put:3;
	at: 1@3 put:4;
	at: 2@1 put:5;
	at: 2@2 put:6;
	at: 2@3 put:7;
	at: 3@1 put:8;
	at: 3@2 put:9;
	at: 3@3 put:10;
	yourself.
	mat3  := (Matriu new: 2) 
	at: 1@1 put:1;
	at: 1@2 put:2;
	at: 2@1 put:3;
	at: 2@2 put:4;
	yourself.
	mat10s := (Matriu new: 5)
	at: 1@1 put:10;
	at: 1@2 put:10;
	at: 1@3 put:10;
	at: 1@4 put:10;
	at: 1@5 put:10;
	at: 2@1 put:10;
	at: 2@2 put:10;
	at: 2@3 put:10;
	at: 2@4 put:10;
	at: 2@5 put:10;
	at: 3@1 put:10;
	at: 3@2 put:10;
	at: 3@3 put:10;
	at: 3@4 put:10;
	at: 3@5 put:10;
	at: 4@1 put:10;
	at: 4@2 put:10;
	at: 4@3 put:10;
	at: 4@4 put:10;
	at: 4@5 put:10;
	at: 5@1 put:10;
	at: 5@2 put:10;
	at: 5@3 put:10;
	at: 5@4 put:10;
	at: 5@5 put:10;
	yourself.! !

!MatriuTest methodsFor: 'tests' stamp: 'GerardCanal 11/1/2012 20:02'!
testIguals
	|tens|
	tens := (Matriu new: 5 with: 10).
	self assert: tens = mat10s.
	self assert: mat10s = tens.
	self assert: tens ~= mat11.
	self assert: mat1 = mat11.
	self assert: mat1 ~= mat2.
	self assert: mat11 ~= mat2.
	self assert: mat3 = mat3.
	self assert: mat3 ~= mat2.
	self assert: mat3 ~= mat1.! !

!MatriuTest methodsFor: 'tests' stamp: 'GerardCanal 11/5/2012 00:28'!
testResta
	|uMenysDos tresMenysTres|
	uMenysDos := (Matriu new: mat1 size)
		at: 1@1 put: -1;
		at: 1@2 put: -1;
		at: 1@3 put: -1;
		at: 2@1 put: -1;
		at: 2@2 put: -1;
		at: 2@3 put: -1;
		at: 3@1 put: -1;
		at: 3@2 put: -1;
		at: 3@3 put: -1;
		yourself.
	tresMenysTres := (Matriu new: mat3 size)
		at: 1@1 put:0;
		at: 1@2 put:0;
		at: 2@1 put:0;
		at: 2@2 put:0;
		yourself.
	
	self assert: tresMenysTres = (mat3 - mat3).
	self assert: uMenysDos = (mat1 - mat2).
	self assert: mat2 - mat1 ~= uMenysDos.
	self assert: mat3 - mat3 = tresMenysTres.
	self assert: mat1 - mat2 = uMenysDos .
	self should: [mat3 - mat2] raise: Error.! !

!MatriuTest methodsFor: 'tests' stamp: 'GerardCanal 11/5/2012 00:27'!
testSuma
	|uMesDos tresMesTres|
	uMesDos := (Matriu new: mat1 size)
		at: 1@1 put:3;
		at: 1@2 put:5;
		at: 1@3 put:7;
		at: 2@1 put:9;
		at: 2@2 put:11;
		at: 2@3 put:13;
		at: 3@1 put:15;
		at: 3@2 put:17;
		at: 3@3 put:19;
		yourself.
	tresMesTres := (Matriu new: mat3 size)
		at: 1@1 put:2;
		at: 1@2 put:4;
		at: 2@1 put:6;
		at: 2@2 put:8;
		yourself.
		
	self assert: mat1 + mat2 = uMesDos.
	self assert: mat3+mat3 = tresMesTres .
	self assert: mat1+mat1 ~= mat2.
	self assert: mat2+mat2 ~= uMesDos .
	self should: [mat1 + mat3] raise: Error.! !
